/* compile.c
	P.Chongstitvatana
	19 Aug 97
	1 Sept 97
	3 Apr 2001  start project RZ
	1 Jan 2002  generate s2 code
*/

#include "compile.h"

extern int DS;              /* from stmt.c  */
extern int CP;

extern int pass(void);		/* parse.c */
extern void rzloop2();		/* s2 code generator */

FILE *FO;					/* output file */

void strcat2(char *s1, char *s2, char *s3){
	strcpy(s1,s2);
	strcat(s1,s3);
}

void main( int argc, char *argv[] )
{
  string source, code, list, iasm, name;
  char *fname;

  if( argc < 2 ) {
    printf("usage : compile source\n");
    exit(-1);
  }
  strcpy(source,argv[1]);
  strcpy(name,source);
  fname = strtok(name,".");
  if( fname == NULL ) fname = name;
  strcat2(code,fname,".out");
  strcat2(list,fname,".lst");
  strcat2(iasm,fname,".s2");

  initCharType();
  readinfile(source);
  getC();
  pass();
  reName();

//  dumpSymTab();

  FO = fopen(iasm,"wt");
  rzloop2();
  fclose(FO);

  FO = fopen(code,"wb");
  writeHead(FO,CP,DS);
  dumpCode();
  fclose(FO);

  FO = fopen(list,"wt");
  showCode();
  fclose(FO);
}

